/* Name: main.c
 * Project: UF lampa
 * Author: r13-project.ru
 * Creation Date: 07-09-19
 */

#include <avr/io.h>         // библиотека ввода вывода
#include <util/delay.h>     // библиотека задержек
#include <avr/interrupt.h>  // библиотека прерываний
#include "light_ws2812.h"   // библиотека работа с диодами ws2812
//#include "ws2812_config.h"
#include "light_ws2812.c"

#define MAX_LED 16           // Количество диодов
#define STEP    30           // Скорость переключения (1000=1секунда)
#define LED_PIN    2         // Пин на котором висит лента


////////////////////////////////////////////////
//Цвет поворотника, цвета задаются от 0 до 255//
#define RED   50            // Яркость красного
#define GREEN 50            // Яркость зеленого
#define BLUE  50            // Яркость синего 
//////////////////////////////////////////////// 
#define MAX_F  150         // Максимальная яркость ленты

#define PIX_PIN  0           // количество ярких
#define MAX_LEN  8             // Длина хвоста

struct cRGB led[MAX_LED];    // Структура для хранения (видеопамять)
struct cRGB led_dot[1];      // Структура для хранения  при анимации

/*
void raduga(void)     
{//заполняем буфер радугой +
unsigned int i;
for(i=0; i<MAX_LED; i++)
     {
      if (i<MAX_LED/3)
	   {
	   led[i].r=MAX_F-(MAX_F/(MAX_LED/3)*i);led[i].g=MAX_F/(MAX_LED/3)*i;led[i].b=0;
	   }
	   else
	   {
		   if ((i>=MAX_LED/3)&&(i<=(MAX_LED/3)*2))
		   {
		   led[i].r=0;led[i].g=MAX_F-MAX_F/(MAX_LED/3)*(i-(MAX_LED/3));led[i].b=(MAX_F/(MAX_LED/3))*(i-(MAX_LED/3));
		   }
           else
           {
			led[i].r=MAX_F/(MAX_LED/3)*(i-2*(MAX_LED/3));led[i].g=0;led[i].b=MAX_F-MAX_F/(MAX_LED/3)*(i-2*(MAX_LED/3));   
           }	
	   }
	 }	
}*/

void raduga(unsigned char KOL_LED)     
{//заполняем буфер радугой +
unsigned char i;
for(i=0; i<KOL_LED; i++)
     {
      if (i<KOL_LED/3)
	   {
	   led[i].r=MAX_F-(MAX_F/(KOL_LED/3)*i);led[i].g=MAX_F/(KOL_LED/3)*i;led[i].b=0;
	   }
	   else
	   {
		   if ((i>=KOL_LED/3)&&(i<=(KOL_LED/3)*2))
		   {
		   led[i].r=0;led[i].g=MAX_F-MAX_F/(KOL_LED/3)*(i-(KOL_LED/3));led[i].b=(MAX_F/(KOL_LED/3))*(i-(KOL_LED/3));
		   }
           else
           {
			led[i].r=MAX_F/(KOL_LED/3)*(i-2*(KOL_LED/3));
			led[i].g=0;
			if ( i== KOL_LED-1)
			led[i].b=0;
            else		
			led[i].b=MAX_F-(MAX_F/(KOL_LED/3)*(i-2*(KOL_LED/3)));   
           }	
	   }
	 }	
}

void clear_LED(void)  
{//очищаем буфер +
  unsigned char i;
   for(i=0; i<MAX_LED; i++)
   {    
   led[i].r=0;led[i].g=0;led[i].b=0;
   }
}

void step_right(void)
{//сдвиг всех пикселей вправо а 1 первый пиксель черным цветом +
	unsigned char i;
	for (i=MAX_LED-1;i>0;i--)
	{
	led[i].r=led[i-1].r;led[i].g=led[i-1].g;led[i].b=led[i-1].b;	
	}
	led[0].r=0; led[0].g=0; led[0].b=0; //или не черным - сюда писать каким заливать
}

void right_out (void)  
{// буфер уползает вправо за экран +
unsigned char i;
    for (i=0; i<MAX_LED;i++)	
    {
	step_right();
	_delay_ms(STEP);
    ws2812_sendarray((uint8_t *)led,(MAX_LED)*3);
    }			
}

void step_right_loop(void)
{//сдвиг всех пикселей влево по кругу на 1 +
	unsigned char i=MAX_LED-1;
    led_dot[0].r=led[i].r; led_dot[0].g=led[i].g; led_dot[0].b=led[i].b;
	for (i=MAX_LED-1;i>0;i--)
	{
	led[i].r=led[i-1].r;led[i].g=led[i-1].g;led[i].b=led[i-1].b;	
	}	  
      led[0].r=led_dot[0].r; led[0].g=led_dot[0].g;	led[0].b=led_dot[0].b;	
}

void step_left(void)
{//сдвиг всех пикселей влево на 1 первый пиксель черным цветом +
unsigned char i=0;

	for(i=0; i<MAX_LED-1; i++)
     {    
      led[i].r=led[i+1].r; led[i].g=led[i+1].g; led[i].b=led[i+1].b;
     }
     led[i].r=0; led[i].g=0; led[i].b=0;	 
}

void right_in (void)  
{// буфер вползает вправо из-за экрана +
	unsigned char i;
	unsigned char j;
	raduga(MAX_LED);
	for (i=MAX_LED-1; i>0; i--)
	{  
	   raduga(MAX_LED);
	   
	   for(j=i ; j>0 ; j--)
	   {
       step_left();
	   }
	   _delay_ms(STEP);
		ws2812_sendarray((uint8_t *)led,(MAX_LED)*3);
	}
	raduga(MAX_LED);
	_delay_ms(STEP);
	ws2812_sendarray((uint8_t *)led,(MAX_LED)*3);
}

/*void left_out(void) 
{// буфер уползает влево за экран +
unsigned char i;
	for (i=0; i<=MAX_LED; i++)
	{
	_delay_ms(STEP);
    ws2812_sendarray((uint8_t *)led+i*3,(MAX_LED-i+1)*3);
	}	
}*/

void left_out(void) 
{// буфер уползает влево за экран +
unsigned char i;
	for (i=0; i<=MAX_LED; i++)
	{
	step_left();	
	_delay_ms(STEP);
    ws2812_sendarray((uint8_t *)led,(MAX_LED)*3);
	}	
}

void left_in (void) 
{// буфер вползает влево из-за экрана
unsigned char i;
unsigned char j;
    for (j=MAX_LED-1; j>0;j--)	
    {
	raduga(MAX_LED);  	
	for (i=j; i>0; i--)  //что бы забивать первые пикселы черным цветом
	{
    step_right();
	}
	_delay_ms(STEP);
    ws2812_sendarray((uint8_t *)led,(MAX_LED)*3);
  }
 raduga(MAX_LED);
 ws2812_sendarray((uint8_t *)led,(MAX_LED)*3);
}

void step_left_loop(void)
{//сдвиг всех пикселей влево по кругу на 1+
	unsigned char i=0;
    led_dot[0].r=led[0].r; led_dot[0].g=led[0].g; led_dot[0].b=led[0].b;
	for(i=0; i<MAX_LED-1; i++)
     {    
      led[i].r=led[i+1].r; led[i].g=led[i+1].g;	led[i].b=led[i+1].b;
     }	  
      led[i].r=led_dot[0].r; led[i].g=led_dot[0].g;	led[i].b=led_dot[0].b;	
}

void step_right_kolstep(unsigned char  step)
{//сдвиг всех пикселей вправо на kolstep пикселей первые пиксели черным цветом +
     if(step>0)
	{
		unsigned char j;
	     for (j=0; j<step; j++)
	     {
         step_right();
	     }
    }
}


/*
1 - радуга
2- пошевелить  радуга динамичная.
3 - наклон вправл
4- наклон влево
5- радуга статичная с выездом
7 ихгиб внутрь
8 перекаты
радуга статичная.
*/



int main(void)
{
    unsigned char i=0;	
    DDRB|=1<<LED_PIN;
	
    clear_LED();
    raduga(MAX_LED); 
    ws2812_sendarray((uint8_t *)led,MAX_LED*3);
	_delay_ms(5000);
	
    right_out();
    _delay_ms(1500);
	
	left_in();
	left_out();
	_delay_ms(1500);
	
	
	raduga(MAX_LED);
	right_in();
	_delay_ms(1500); 
	
	
// уменьшаемся	
	for (i=MAX_LED ; i>=3; i--)
	{
	clear_LED();	
	raduga(i);
	step_right_kolstep((MAX_LED-i)/2);
	
	ws2812_sendarray((uint8_t *)led,MAX_LED*3);
	_delay_ms(STEP*2);	
	}
	_delay_ms(500);	
// увеличиваемся		
	for (i=3 ; i<=MAX_LED; i++)
	{
	clear_LED();	
	raduga(i);
	step_right_kolstep((MAX_LED-i)/2);
	
	ws2812_sendarray((uint8_t *)led,MAX_LED*3);
	_delay_ms(STEP*2);	
	}
_delay_ms(500);
// уменьшаемся	
		for (i=MAX_LED ; i>=3; i--)
	{
	clear_LED();	
	raduga(i);
	step_right_kolstep((MAX_LED-i)/2);
	
	ws2812_sendarray((uint8_t *)led,MAX_LED*3);
	_delay_ms(STEP*2);	
	}
	_delay_ms(1000);
//скольжение в край	
	for (i=0 ; i<(MAX_LED-3)/2; i++)
	{	
	  step_left_loop();	  
      ws2812_sendarray((uint8_t *)led,MAX_LED*3);
	  _delay_ms(STEP*3);
	}
	
/*	for (i=0 ; i<12; i++)
	{	
	  step_right_loop();	  
      ws2812_sendarray((uint8_t *)led,MAX_LED*3);
	  _delay_ms(STEP);
	}

	for (i=0 ; i<12; i++)
	{	
	  step_left_loop();	  
      ws2812_sendarray((uint8_t *)led,MAX_LED*3);
	  _delay_ms(STEP);
	}
	
	for (i=0 ; i<12; i++)
	{	
	  step_right_loop();	  
      ws2812_sendarray((uint8_t *)led,MAX_LED*3);
	  _delay_ms(STEP);
	}	
	*/
	
i=0;
char n=0, e=0, l=1;
  while (1)
  {
	  
	if (e<((MAX_LED)*5)+9){ // *5+9 - задает количество шагов светодиодов
		
	  if (n==0)
	  {
		    if (i<MAX_LED-3)
		    {
		     step_right_loop();
	         i++;
		    }
			else {n=1;}
	  }
      else
	  {
	  if (i>0)
		    {
		     step_left_loop();
	         i--;
		    }
			else {n=0;}
	  }	 
	  
      ws2812_sendarray((uint8_t *)led,MAX_LED*3);
	  _delay_ms(STEP*3);
	  
	  e++;
	}
	else{
		if (l!=0){
			_delay_ms(600);
			for (i=3 ; i<=MAX_LED; i++){
				clear_LED();	
				raduga(i);
				step_right_kolstep((MAX_LED-i)/2);
				ws2812_sendarray((uint8_t *)led,MAX_LED*3);
				_delay_ms(STEP*2);	
				}
			raduga(MAX_LED); 
			ws2812_sendarray((uint8_t *)led,MAX_LED*3);
		}
	l=0;	
	}
  
  }

}